import Criterion.Main
import Criterion.Config
import Criterion.MultiMap
import Data.Monoid
import System.IO
import System.Process

runPrimeBF :: String -> Int -> IO ()
runPrimeBF interp n = do
  let spec = CreateProcess {
    cmdspec = RawCommand interp ["PRIME.BF"],
    cwd = Nothing,
    env = Nothing,
    std_in = CreatePipe,
    std_out = CreatePipe,
    std_err = Inherit,
    close_fds = True}
  run <- createProcess spec
  let (Just stdin, _, _, proc) = run
  hSetBinaryMode stdin False
  hSetBuffering stdin LineBuffering
  hPutStrLn stdin (show n)
  waitForProcess proc
  return ()

config :: Config
config = defaultConfig {cfgPlot = singleton Timing CSV}

main :: IO ()
main = defaultMainWith config (return ()) [
  bgroup "orig" [
    bench "50"  $ runPrimeBF "./bfi-orig" 50,
    bench "75"  $ runPrimeBF "./bfi-orig" 75,
    bench "100" $ runPrimeBF "./bfi-orig" 100,
    bench "125" $ runPrimeBF "./bfi-orig" 125,
    bench "150" $ runPrimeBF "./bfi-orig" 150,
    bench "175" $ runPrimeBF "./bfi-orig" 175,
    bench "200" $ runPrimeBF "./bfi-orig" 200,
    bench "225" $ runPrimeBF "./bfi-orig" 225,
    bench "250" $ runPrimeBF "./bfi-orig" 250],
  bgroup "xformed" [
    bench "50"  $ runPrimeBF "./bfi-xformed" 50,
    bench "75"  $ runPrimeBF "./bfi-xformed" 75,
    bench "100" $ runPrimeBF "./bfi-xformed" 100,
    bench "125" $ runPrimeBF "./bfi-xformed" 125,
    bench "150" $ runPrimeBF "./bfi-xformed" 150,
    bench "175" $ runPrimeBF "./bfi-xformed" 175,
    bench "200" $ runPrimeBF "./bfi-xformed" 200,
    bench "225" $ runPrimeBF "./bfi-xformed" 225,
    bench "250" $ runPrimeBF "./bfi-xformed" 250]]
