#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAX_PROG 30000
#define MAX_DATA 30000

#ifdef ENABLE_AUTOJIT
extern int __autojit__cvar_int(int);
#else
#define __autojit__cvar_int(x) (x)
#endif

int main(int argc, char** argv)
{
  int prog[MAX_PROG], prog_len, data[MAX_DATA];

  if (argc != 2) {return EXIT_FAILURE;}
  FILE* prog_file = fopen(argv[1], "r");
  if (!prog_file) {return EXIT_FAILURE;}
  for (prog_len=0; prog_len<MAX_PROG &&
         (prog[prog_len] = getc(prog_file)) != EOF; prog_len++) {}
  fclose(prog_file);

  memset(data, 0, MAX_DATA*sizeof(int));

  for (int prog_idx = __autojit__cvar_int(0), data_idx = 0;
       prog_idx < prog_len; prog_idx++) {
    switch (prog[prog_idx]) {
      case '+': data[data_idx]++; break;
      case '-': data[data_idx]--; break;
      case '>': data_idx++; break;
      case '<': data_idx--; break;
      case '.': putchar(data[data_idx]); break;
      case ',': data[data_idx] = getchar(); break;
      case '[': prog_idx++;
        if (!data[data_idx]) {
          for (int nesting = 1; nesting > 0; prog_idx++) {
            if (prog[prog_idx] == '[') {nesting++;} else
            if (prog[prog_idx] == ']') {nesting--;}
          }
        } prog_idx--; break;
      case ']': prog_idx--;
        for (int nesting = 1; nesting > 0; prog_idx--) {
          if (prog[prog_idx] == ']') {nesting++;} else
          if (prog[prog_idx] == '[') {nesting--;}
        } break;
      default: break;
    }
  }

  return EXIT_SUCCESS;
}
